// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_control_msgs:msg/ActuatorControls.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/actuator_controls.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__TRAITS_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_control_msgs/msg/detail/actuator_controls__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hippo_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ActuatorControls & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: control
  {
    if (msg.control.size() == 0) {
      out << "control: []";
    } else {
      out << "control: [";
      size_t pending_items = msg.control.size();
      for (auto item : msg.control) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ActuatorControls & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: control
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.control.size() == 0) {
      out << "control: []\n";
    } else {
      out << "control:\n";
      for (auto item : msg.control) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ActuatorControls & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_control_msgs::msg::ActuatorControls & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_control_msgs::msg::ActuatorControls & msg)
{
  return hippo_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_control_msgs::msg::ActuatorControls>()
{
  return "hippo_control_msgs::msg::ActuatorControls";
}

template<>
inline const char * name<hippo_control_msgs::msg::ActuatorControls>()
{
  return "hippo_control_msgs/msg/ActuatorControls";
}

template<>
struct has_fixed_size<hippo_control_msgs::msg::ActuatorControls>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_control_msgs::msg::ActuatorControls>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_control_msgs::msg::ActuatorControls>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__TRAITS_HPP_
