// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/ActuatorSetpoint.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/actuator_setpoint.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__ActuatorSetpoint __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__ActuatorSetpoint __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ActuatorSetpoint_
{
  using Type = ActuatorSetpoint_<ContainerAllocator>;

  explicit ActuatorSetpoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_x = false;
      this->ignore_y = false;
      this->ignore_z = false;
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
    }
  }

  explicit ActuatorSetpoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_x = false;
      this->ignore_y = false;
      this->ignore_z = false;
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _ignore_x_type =
    bool;
  _ignore_x_type ignore_x;
  using _ignore_y_type =
    bool;
  _ignore_y_type ignore_y;
  using _ignore_z_type =
    bool;
  _ignore_z_type ignore_z;
  using _x_type =
    double;
  _x_type x;
  using _y_type =
    double;
  _y_type y;
  using _z_type =
    double;
  _z_type z;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__ignore_x(
    const bool & _arg)
  {
    this->ignore_x = _arg;
    return *this;
  }
  Type & set__ignore_y(
    const bool & _arg)
  {
    this->ignore_y = _arg;
    return *this;
  }
  Type & set__ignore_z(
    const bool & _arg)
  {
    this->ignore_z = _arg;
    return *this;
  }
  Type & set__x(
    const double & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const double & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const double & _arg)
  {
    this->z = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__ActuatorSetpoint
    std::shared_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__ActuatorSetpoint
    std::shared_ptr<hippo_control_msgs::msg::ActuatorSetpoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ActuatorSetpoint_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->ignore_x != other.ignore_x) {
      return false;
    }
    if (this->ignore_y != other.ignore_y) {
      return false;
    }
    if (this->ignore_z != other.ignore_z) {
      return false;
    }
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    return true;
  }
  bool operator!=(const ActuatorSetpoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ActuatorSetpoint_

// alias to use template instance with default allocator
using ActuatorSetpoint =
  hippo_control_msgs::msg::ActuatorSetpoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__STRUCT_HPP_
