// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hippo_control_msgs:msg/AttitudeTarget.idl
// generated code does not contain a copyright notice
#include "hippo_control_msgs/msg/detail/attitude_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `attitude`
#include "geometry_msgs/msg/detail/quaternion__functions.h"
// Member `body_rate`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
hippo_control_msgs__msg__AttitudeTarget__init(hippo_control_msgs__msg__AttitudeTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    hippo_control_msgs__msg__AttitudeTarget__fini(msg);
    return false;
  }
  // mask
  // thrust
  // attitude
  if (!geometry_msgs__msg__Quaternion__init(&msg->attitude)) {
    hippo_control_msgs__msg__AttitudeTarget__fini(msg);
    return false;
  }
  // body_rate
  if (!geometry_msgs__msg__Vector3__init(&msg->body_rate)) {
    hippo_control_msgs__msg__AttitudeTarget__fini(msg);
    return false;
  }
  return true;
}

void
hippo_control_msgs__msg__AttitudeTarget__fini(hippo_control_msgs__msg__AttitudeTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // mask
  // thrust
  // attitude
  geometry_msgs__msg__Quaternion__fini(&msg->attitude);
  // body_rate
  geometry_msgs__msg__Vector3__fini(&msg->body_rate);
}

bool
hippo_control_msgs__msg__AttitudeTarget__are_equal(const hippo_control_msgs__msg__AttitudeTarget * lhs, const hippo_control_msgs__msg__AttitudeTarget * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // mask
  if (lhs->mask != rhs->mask) {
    return false;
  }
  // thrust
  if (lhs->thrust != rhs->thrust) {
    return false;
  }
  // attitude
  if (!geometry_msgs__msg__Quaternion__are_equal(
      &(lhs->attitude), &(rhs->attitude)))
  {
    return false;
  }
  // body_rate
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->body_rate), &(rhs->body_rate)))
  {
    return false;
  }
  return true;
}

bool
hippo_control_msgs__msg__AttitudeTarget__copy(
  const hippo_control_msgs__msg__AttitudeTarget * input,
  hippo_control_msgs__msg__AttitudeTarget * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // mask
  output->mask = input->mask;
  // thrust
  output->thrust = input->thrust;
  // attitude
  if (!geometry_msgs__msg__Quaternion__copy(
      &(input->attitude), &(output->attitude)))
  {
    return false;
  }
  // body_rate
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->body_rate), &(output->body_rate)))
  {
    return false;
  }
  return true;
}

hippo_control_msgs__msg__AttitudeTarget *
hippo_control_msgs__msg__AttitudeTarget__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__AttitudeTarget * msg = (hippo_control_msgs__msg__AttitudeTarget *)allocator.allocate(sizeof(hippo_control_msgs__msg__AttitudeTarget), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hippo_control_msgs__msg__AttitudeTarget));
  bool success = hippo_control_msgs__msg__AttitudeTarget__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hippo_control_msgs__msg__AttitudeTarget__destroy(hippo_control_msgs__msg__AttitudeTarget * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hippo_control_msgs__msg__AttitudeTarget__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hippo_control_msgs__msg__AttitudeTarget__Sequence__init(hippo_control_msgs__msg__AttitudeTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__AttitudeTarget * data = NULL;

  if (size) {
    data = (hippo_control_msgs__msg__AttitudeTarget *)allocator.zero_allocate(size, sizeof(hippo_control_msgs__msg__AttitudeTarget), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hippo_control_msgs__msg__AttitudeTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hippo_control_msgs__msg__AttitudeTarget__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hippo_control_msgs__msg__AttitudeTarget__Sequence__fini(hippo_control_msgs__msg__AttitudeTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hippo_control_msgs__msg__AttitudeTarget__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hippo_control_msgs__msg__AttitudeTarget__Sequence *
hippo_control_msgs__msg__AttitudeTarget__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__AttitudeTarget__Sequence * array = (hippo_control_msgs__msg__AttitudeTarget__Sequence *)allocator.allocate(sizeof(hippo_control_msgs__msg__AttitudeTarget__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hippo_control_msgs__msg__AttitudeTarget__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hippo_control_msgs__msg__AttitudeTarget__Sequence__destroy(hippo_control_msgs__msg__AttitudeTarget__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hippo_control_msgs__msg__AttitudeTarget__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hippo_control_msgs__msg__AttitudeTarget__Sequence__are_equal(const hippo_control_msgs__msg__AttitudeTarget__Sequence * lhs, const hippo_control_msgs__msg__AttitudeTarget__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hippo_control_msgs__msg__AttitudeTarget__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hippo_control_msgs__msg__AttitudeTarget__Sequence__copy(
  const hippo_control_msgs__msg__AttitudeTarget__Sequence * input,
  hippo_control_msgs__msg__AttitudeTarget__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hippo_control_msgs__msg__AttitudeTarget);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hippo_control_msgs__msg__AttitudeTarget * data =
      (hippo_control_msgs__msg__AttitudeTarget *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hippo_control_msgs__msg__AttitudeTarget__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hippo_control_msgs__msg__AttitudeTarget__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hippo_control_msgs__msg__AttitudeTarget__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
