// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/FailureControlDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/failure_control_debug.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'desired_thrust'
// Member 'desired_torque'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__FailureControlDebug __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__FailureControlDebug __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FailureControlDebug_
{
  using Type = FailureControlDebug_<ContainerAllocator>;

  explicit FailureControlDebug_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    desired_thrust(_init),
    desired_torque(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->allocated_thrust.begin(), this->allocated_thrust.end(), 0.0);
      std::fill<typename std::array<double, 16>::iterator, double>(this->thrust_composition.begin(), this->thrust_composition.end(), 0.0);
      this->controllability_scaler = 0.0;
    }
  }

  explicit FailureControlDebug_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    desired_thrust(_alloc, _init),
    desired_torque(_alloc, _init),
    allocated_thrust(_alloc),
    thrust_composition(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->allocated_thrust.begin(), this->allocated_thrust.end(), 0.0);
      std::fill<typename std::array<double, 16>::iterator, double>(this->thrust_composition.begin(), this->thrust_composition.end(), 0.0);
      this->controllability_scaler = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _desired_thrust_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _desired_thrust_type desired_thrust;
  using _desired_torque_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _desired_torque_type desired_torque;
  using _allocated_thrust_type =
    std::array<double, 8>;
  _allocated_thrust_type allocated_thrust;
  using _thrust_composition_type =
    std::array<double, 16>;
  _thrust_composition_type thrust_composition;
  using _controllability_scaler_type =
    double;
  _controllability_scaler_type controllability_scaler;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__desired_thrust(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->desired_thrust = _arg;
    return *this;
  }
  Type & set__desired_torque(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->desired_torque = _arg;
    return *this;
  }
  Type & set__allocated_thrust(
    const std::array<double, 8> & _arg)
  {
    this->allocated_thrust = _arg;
    return *this;
  }
  Type & set__thrust_composition(
    const std::array<double, 16> & _arg)
  {
    this->thrust_composition = _arg;
    return *this;
  }
  Type & set__controllability_scaler(
    const double & _arg)
  {
    this->controllability_scaler = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__FailureControlDebug
    std::shared_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__FailureControlDebug
    std::shared_ptr<hippo_control_msgs::msg::FailureControlDebug_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FailureControlDebug_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->desired_thrust != other.desired_thrust) {
      return false;
    }
    if (this->desired_torque != other.desired_torque) {
      return false;
    }
    if (this->allocated_thrust != other.allocated_thrust) {
      return false;
    }
    if (this->thrust_composition != other.thrust_composition) {
      return false;
    }
    if (this->controllability_scaler != other.controllability_scaler) {
      return false;
    }
    return true;
  }
  bool operator!=(const FailureControlDebug_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FailureControlDebug_

// alias to use template instance with default allocator
using FailureControlDebug =
  hippo_control_msgs::msg::FailureControlDebug_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__STRUCT_HPP_
