// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hippo_control_msgs:msg/FailureControlMode.idl
// generated code does not contain a copyright notice
#include "hippo_control_msgs/msg/detail/failure_control_mode__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
hippo_control_msgs__msg__FailureControlMode__init(hippo_control_msgs__msg__FailureControlMode * msg)
{
  if (!msg) {
    return false;
  }
  // mode
  return true;
}

void
hippo_control_msgs__msg__FailureControlMode__fini(hippo_control_msgs__msg__FailureControlMode * msg)
{
  if (!msg) {
    return;
  }
  // mode
}

bool
hippo_control_msgs__msg__FailureControlMode__are_equal(const hippo_control_msgs__msg__FailureControlMode * lhs, const hippo_control_msgs__msg__FailureControlMode * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // mode
  if (lhs->mode != rhs->mode) {
    return false;
  }
  return true;
}

bool
hippo_control_msgs__msg__FailureControlMode__copy(
  const hippo_control_msgs__msg__FailureControlMode * input,
  hippo_control_msgs__msg__FailureControlMode * output)
{
  if (!input || !output) {
    return false;
  }
  // mode
  output->mode = input->mode;
  return true;
}

hippo_control_msgs__msg__FailureControlMode *
hippo_control_msgs__msg__FailureControlMode__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__FailureControlMode * msg = (hippo_control_msgs__msg__FailureControlMode *)allocator.allocate(sizeof(hippo_control_msgs__msg__FailureControlMode), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hippo_control_msgs__msg__FailureControlMode));
  bool success = hippo_control_msgs__msg__FailureControlMode__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hippo_control_msgs__msg__FailureControlMode__destroy(hippo_control_msgs__msg__FailureControlMode * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hippo_control_msgs__msg__FailureControlMode__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hippo_control_msgs__msg__FailureControlMode__Sequence__init(hippo_control_msgs__msg__FailureControlMode__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__FailureControlMode * data = NULL;

  if (size) {
    data = (hippo_control_msgs__msg__FailureControlMode *)allocator.zero_allocate(size, sizeof(hippo_control_msgs__msg__FailureControlMode), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hippo_control_msgs__msg__FailureControlMode__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hippo_control_msgs__msg__FailureControlMode__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hippo_control_msgs__msg__FailureControlMode__Sequence__fini(hippo_control_msgs__msg__FailureControlMode__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hippo_control_msgs__msg__FailureControlMode__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hippo_control_msgs__msg__FailureControlMode__Sequence *
hippo_control_msgs__msg__FailureControlMode__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__FailureControlMode__Sequence * array = (hippo_control_msgs__msg__FailureControlMode__Sequence *)allocator.allocate(sizeof(hippo_control_msgs__msg__FailureControlMode__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hippo_control_msgs__msg__FailureControlMode__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hippo_control_msgs__msg__FailureControlMode__Sequence__destroy(hippo_control_msgs__msg__FailureControlMode__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hippo_control_msgs__msg__FailureControlMode__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hippo_control_msgs__msg__FailureControlMode__Sequence__are_equal(const hippo_control_msgs__msg__FailureControlMode__Sequence * lhs, const hippo_control_msgs__msg__FailureControlMode__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hippo_control_msgs__msg__FailureControlMode__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hippo_control_msgs__msg__FailureControlMode__Sequence__copy(
  const hippo_control_msgs__msg__FailureControlMode__Sequence * input,
  hippo_control_msgs__msg__FailureControlMode__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hippo_control_msgs__msg__FailureControlMode);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hippo_control_msgs__msg__FailureControlMode * data =
      (hippo_control_msgs__msg__FailureControlMode *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hippo_control_msgs__msg__FailureControlMode__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hippo_control_msgs__msg__FailureControlMode__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hippo_control_msgs__msg__FailureControlMode__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
