// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hippo_control_msgs:msg/PIDDebug.idl
// generated code does not contain a copyright notice
#include "hippo_control_msgs/msg/detail/pid_debug__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
hippo_control_msgs__msg__PIDDebug__init(hippo_control_msgs__msg__PIDDebug * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    hippo_control_msgs__msg__PIDDebug__fini(msg);
    return false;
  }
  // dt
  // error
  // derror
  // p_term
  // i_term
  // d_term
  // p_gain
  // i_gain
  // d_gain
  // i_max
  // i_min
  // output
  return true;
}

void
hippo_control_msgs__msg__PIDDebug__fini(hippo_control_msgs__msg__PIDDebug * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // dt
  // error
  // derror
  // p_term
  // i_term
  // d_term
  // p_gain
  // i_gain
  // d_gain
  // i_max
  // i_min
  // output
}

bool
hippo_control_msgs__msg__PIDDebug__are_equal(const hippo_control_msgs__msg__PIDDebug * lhs, const hippo_control_msgs__msg__PIDDebug * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // dt
  if (lhs->dt != rhs->dt) {
    return false;
  }
  // error
  if (lhs->error != rhs->error) {
    return false;
  }
  // derror
  if (lhs->derror != rhs->derror) {
    return false;
  }
  // p_term
  if (lhs->p_term != rhs->p_term) {
    return false;
  }
  // i_term
  if (lhs->i_term != rhs->i_term) {
    return false;
  }
  // d_term
  if (lhs->d_term != rhs->d_term) {
    return false;
  }
  // p_gain
  if (lhs->p_gain != rhs->p_gain) {
    return false;
  }
  // i_gain
  if (lhs->i_gain != rhs->i_gain) {
    return false;
  }
  // d_gain
  if (lhs->d_gain != rhs->d_gain) {
    return false;
  }
  // i_max
  if (lhs->i_max != rhs->i_max) {
    return false;
  }
  // i_min
  if (lhs->i_min != rhs->i_min) {
    return false;
  }
  // output
  if (lhs->output != rhs->output) {
    return false;
  }
  return true;
}

bool
hippo_control_msgs__msg__PIDDebug__copy(
  const hippo_control_msgs__msg__PIDDebug * input,
  hippo_control_msgs__msg__PIDDebug * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // dt
  output->dt = input->dt;
  // error
  output->error = input->error;
  // derror
  output->derror = input->derror;
  // p_term
  output->p_term = input->p_term;
  // i_term
  output->i_term = input->i_term;
  // d_term
  output->d_term = input->d_term;
  // p_gain
  output->p_gain = input->p_gain;
  // i_gain
  output->i_gain = input->i_gain;
  // d_gain
  output->d_gain = input->d_gain;
  // i_max
  output->i_max = input->i_max;
  // i_min
  output->i_min = input->i_min;
  // output
  output->output = input->output;
  return true;
}

hippo_control_msgs__msg__PIDDebug *
hippo_control_msgs__msg__PIDDebug__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__PIDDebug * msg = (hippo_control_msgs__msg__PIDDebug *)allocator.allocate(sizeof(hippo_control_msgs__msg__PIDDebug), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hippo_control_msgs__msg__PIDDebug));
  bool success = hippo_control_msgs__msg__PIDDebug__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hippo_control_msgs__msg__PIDDebug__destroy(hippo_control_msgs__msg__PIDDebug * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hippo_control_msgs__msg__PIDDebug__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hippo_control_msgs__msg__PIDDebug__Sequence__init(hippo_control_msgs__msg__PIDDebug__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__PIDDebug * data = NULL;

  if (size) {
    data = (hippo_control_msgs__msg__PIDDebug *)allocator.zero_allocate(size, sizeof(hippo_control_msgs__msg__PIDDebug), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hippo_control_msgs__msg__PIDDebug__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hippo_control_msgs__msg__PIDDebug__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hippo_control_msgs__msg__PIDDebug__Sequence__fini(hippo_control_msgs__msg__PIDDebug__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hippo_control_msgs__msg__PIDDebug__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hippo_control_msgs__msg__PIDDebug__Sequence *
hippo_control_msgs__msg__PIDDebug__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__PIDDebug__Sequence * array = (hippo_control_msgs__msg__PIDDebug__Sequence *)allocator.allocate(sizeof(hippo_control_msgs__msg__PIDDebug__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hippo_control_msgs__msg__PIDDebug__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hippo_control_msgs__msg__PIDDebug__Sequence__destroy(hippo_control_msgs__msg__PIDDebug__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hippo_control_msgs__msg__PIDDebug__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hippo_control_msgs__msg__PIDDebug__Sequence__are_equal(const hippo_control_msgs__msg__PIDDebug__Sequence * lhs, const hippo_control_msgs__msg__PIDDebug__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hippo_control_msgs__msg__PIDDebug__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hippo_control_msgs__msg__PIDDebug__Sequence__copy(
  const hippo_control_msgs__msg__PIDDebug__Sequence * input,
  hippo_control_msgs__msg__PIDDebug__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hippo_control_msgs__msg__PIDDebug);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hippo_control_msgs__msg__PIDDebug * data =
      (hippo_control_msgs__msg__PIDDebug *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hippo_control_msgs__msg__PIDDebug__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hippo_control_msgs__msg__PIDDebug__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hippo_control_msgs__msg__PIDDebug__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
