// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/QuaternionControlDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/quaternion_control_debug.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'desired_axis'
// Member 'current_axis'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__QuaternionControlDebug __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__QuaternionControlDebug __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct QuaternionControlDebug_
{
  using Type = QuaternionControlDebug_<ContainerAllocator>;

  explicit QuaternionControlDebug_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    desired_axis(_init),
    current_axis(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->roll_weight = 0.0;
      this->gain = 0.0;
      this->angle_error = 0.0;
    }
  }

  explicit QuaternionControlDebug_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    desired_axis(_alloc, _init),
    current_axis(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->roll_weight = 0.0;
      this->gain = 0.0;
      this->angle_error = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _roll_weight_type =
    double;
  _roll_weight_type roll_weight;
  using _gain_type =
    double;
  _gain_type gain;
  using _desired_axis_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _desired_axis_type desired_axis;
  using _current_axis_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _current_axis_type current_axis;
  using _angle_error_type =
    double;
  _angle_error_type angle_error;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__roll_weight(
    const double & _arg)
  {
    this->roll_weight = _arg;
    return *this;
  }
  Type & set__gain(
    const double & _arg)
  {
    this->gain = _arg;
    return *this;
  }
  Type & set__desired_axis(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->desired_axis = _arg;
    return *this;
  }
  Type & set__current_axis(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->current_axis = _arg;
    return *this;
  }
  Type & set__angle_error(
    const double & _arg)
  {
    this->angle_error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__QuaternionControlDebug
    std::shared_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__QuaternionControlDebug
    std::shared_ptr<hippo_control_msgs::msg::QuaternionControlDebug_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const QuaternionControlDebug_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->roll_weight != other.roll_weight) {
      return false;
    }
    if (this->gain != other.gain) {
      return false;
    }
    if (this->desired_axis != other.desired_axis) {
      return false;
    }
    if (this->current_axis != other.current_axis) {
      return false;
    }
    if (this->angle_error != other.angle_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const QuaternionControlDebug_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct QuaternionControlDebug_

// alias to use template instance with default allocator
using QuaternionControlDebug =
  hippo_control_msgs::msg::QuaternionControlDebug_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__STRUCT_HPP_
