// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/RatesDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/rates_debug.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_DEBUG__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_DEBUG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'rates'
// Member 'rates_desired'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__RatesDebug __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__RatesDebug __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RatesDebug_
{
  using Type = RatesDebug_<ContainerAllocator>;

  explicit RatesDebug_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    rates(_init),
    rates_desired(_init)
  {
    (void)_init;
  }

  explicit RatesDebug_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    rates(_alloc, _init),
    rates_desired(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _rates_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _rates_type rates;
  using _rates_desired_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _rates_desired_type rates_desired;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__rates(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->rates = _arg;
    return *this;
  }
  Type & set__rates_desired(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->rates_desired = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__RatesDebug
    std::shared_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__RatesDebug
    std::shared_ptr<hippo_control_msgs::msg::RatesDebug_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RatesDebug_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->rates != other.rates) {
      return false;
    }
    if (this->rates_desired != other.rates_desired) {
      return false;
    }
    return true;
  }
  bool operator!=(const RatesDebug_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RatesDebug_

// alias to use template instance with default allocator
using RatesDebug =
  hippo_control_msgs::msg::RatesDebug_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_DEBUG__STRUCT_HPP_
