// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/ActuatorControls.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/actuator_controls.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__ActuatorControls __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__ActuatorControls __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ActuatorControls_
{
  using Type = ActuatorControls_<ContainerAllocator>;

  explicit ActuatorControls_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->control.begin(), this->control.end(), 0.0);
    }
  }

  explicit ActuatorControls_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    control(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->control.begin(), this->control.end(), 0.0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _control_type =
    std::array<double, 8>;
  _control_type control;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__control(
    const std::array<double, 8> & _arg)
  {
    this->control = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t HIPPO_PORT_TOP =
    0u;
  static constexpr uint8_t HIPPO_STARBOARD_TOP =
    1u;
  static constexpr uint8_t HIPPO_STARBOARD_BOT =
    2u;
  static constexpr uint8_t HIPPO_PORT_BOT =
    3u;
  static constexpr uint8_t BLUEROV_HOR_STARBOARD_FRONT =
    0u;
  static constexpr uint8_t BLUEROV_HOR_PORT_FRONT =
    1u;
  static constexpr uint8_t BLUEROV_HOR_STARBOARD_REAR =
    2u;
  static constexpr uint8_t BLUEROV_HOR_PORT_REAR =
    3u;
  static constexpr uint8_t BLUEROV_VERT_STARBOARD_FRONT =
    4u;
  static constexpr uint8_t BLUEROV_VERT_PORT_FRONT =
    5u;
  static constexpr uint8_t BLUEROV_VERT_STARBOARD_REAR =
    6u;
  static constexpr uint8_t BLUEROV_VERT_PORT_REAR =
    7u;

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__ActuatorControls
    std::shared_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__ActuatorControls
    std::shared_ptr<hippo_control_msgs::msg::ActuatorControls_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ActuatorControls_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->control != other.control) {
      return false;
    }
    return true;
  }
  bool operator!=(const ActuatorControls_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ActuatorControls_

// alias to use template instance with default allocator
using ActuatorControls =
  hippo_control_msgs::msg::ActuatorControls_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::HIPPO_PORT_TOP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::HIPPO_STARBOARD_TOP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::HIPPO_STARBOARD_BOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::HIPPO_PORT_BOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_HOR_STARBOARD_FRONT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_HOR_PORT_FRONT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_HOR_STARBOARD_REAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_HOR_PORT_REAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_VERT_STARBOARD_FRONT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_VERT_PORT_FRONT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_VERT_STARBOARD_REAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ActuatorControls_<ContainerAllocator>::BLUEROV_VERT_PORT_REAR;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_CONTROLS__STRUCT_HPP_
