// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_control_msgs:msg/ActuatorSetpoint.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/actuator_setpoint.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__TRAITS_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_control_msgs/msg/detail/actuator_setpoint__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hippo_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ActuatorSetpoint & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: ignore_x
  {
    out << "ignore_x: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_x, out);
    out << ", ";
  }

  // member: ignore_y
  {
    out << "ignore_y: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_y, out);
    out << ", ";
  }

  // member: ignore_z
  {
    out << "ignore_z: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_z, out);
    out << ", ";
  }

  // member: x
  {
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << ", ";
  }

  // member: y
  {
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << ", ";
  }

  // member: z
  {
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ActuatorSetpoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: ignore_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_x: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_x, out);
    out << "\n";
  }

  // member: ignore_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_y: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_y, out);
    out << "\n";
  }

  // member: ignore_z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_z: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_z, out);
    out << "\n";
  }

  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ActuatorSetpoint & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_control_msgs::msg::ActuatorSetpoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_control_msgs::msg::ActuatorSetpoint & msg)
{
  return hippo_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_control_msgs::msg::ActuatorSetpoint>()
{
  return "hippo_control_msgs::msg::ActuatorSetpoint";
}

template<>
inline const char * name<hippo_control_msgs::msg::ActuatorSetpoint>()
{
  return "hippo_control_msgs/msg/ActuatorSetpoint";
}

template<>
struct has_fixed_size<hippo_control_msgs::msg::ActuatorSetpoint>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_control_msgs::msg::ActuatorSetpoint>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_control_msgs::msg::ActuatorSetpoint>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__ACTUATOR_SETPOINT__TRAITS_HPP_
