// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/ControlTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/control_target.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__CONTROL_TARGET__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__CONTROL_TARGET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.hpp"
// Member 'velocity'
// Member 'acceleration'
// Member 'angular_velocity'
// Member 'angular_acceleration'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"
// Member 'attitude'
#include "geometry_msgs/msg/detail/quaternion__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__ControlTarget __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__ControlTarget __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ControlTarget_
{
  using Type = ControlTarget_<ContainerAllocator>;

  explicit ControlTarget_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    position(_init),
    velocity(_init),
    acceleration(_init),
    attitude(_init),
    angular_velocity(_init),
    angular_acceleration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mask = 0ul;
    }
  }

  explicit ControlTarget_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    position(_alloc, _init),
    velocity(_alloc, _init),
    acceleration(_alloc, _init),
    attitude(_alloc, _init),
    angular_velocity(_alloc, _init),
    angular_acceleration(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mask = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mask_type =
    uint32_t;
  _mask_type mask;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _velocity_type velocity;
  using _acceleration_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _acceleration_type acceleration;
  using _attitude_type =
    geometry_msgs::msg::Quaternion_<ContainerAllocator>;
  _attitude_type attitude;
  using _angular_velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _angular_velocity_type angular_velocity;
  using _angular_acceleration_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _angular_acceleration_type angular_acceleration;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mask(
    const uint32_t & _arg)
  {
    this->mask = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__acceleration(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->acceleration = _arg;
    return *this;
  }
  Type & set__attitude(
    const geometry_msgs::msg::Quaternion_<ContainerAllocator> & _arg)
  {
    this->attitude = _arg;
    return *this;
  }
  Type & set__angular_velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->angular_velocity = _arg;
    return *this;
  }
  Type & set__angular_acceleration(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->angular_acceleration = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t IGNORE_POSITION_X =
    1u;
  static constexpr uint32_t IGNORE_POSITION_Y =
    2u;
  static constexpr uint32_t IGNORE_POSITION_Z =
    4u;
  static constexpr uint32_t IGNORE_POSITION =
    7u;
  static constexpr uint32_t IGNORE_ATTITUDE_X =
    8u;
  static constexpr uint32_t IGNORE_ATTITUDE_Y =
    16u;
  static constexpr uint32_t IGNORE_ATTITUDE_Z =
    32u;
  static constexpr uint32_t IGNORE_ATTITUDE =
    56u;
  static constexpr uint32_t IGNORE_POSE =
    63u;

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__ControlTarget
    std::shared_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__ControlTarget
    std::shared_ptr<hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlTarget_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mask != other.mask) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->acceleration != other.acceleration) {
      return false;
    }
    if (this->attitude != other.attitude) {
      return false;
    }
    if (this->angular_velocity != other.angular_velocity) {
      return false;
    }
    if (this->angular_acceleration != other.angular_acceleration) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlTarget_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlTarget_

// alias to use template instance with default allocator
using ControlTarget =
  hippo_control_msgs::msg::ControlTarget_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_POSITION_X;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_POSITION_Y;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_POSITION_Z;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_ATTITUDE_X;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_ATTITUDE_Y;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_ATTITUDE_Z;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_ATTITUDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ControlTarget_<ContainerAllocator>::IGNORE_POSE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__CONTROL_TARGET__STRUCT_HPP_
