// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_control_msgs:msg/FailureControlDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/failure_control_debug.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__TRAITS_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_control_msgs/msg/detail/failure_control_debug__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'desired_thrust'
// Member 'desired_torque'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace hippo_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FailureControlDebug & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: desired_thrust
  {
    out << "desired_thrust: ";
    to_flow_style_yaml(msg.desired_thrust, out);
    out << ", ";
  }

  // member: desired_torque
  {
    out << "desired_torque: ";
    to_flow_style_yaml(msg.desired_torque, out);
    out << ", ";
  }

  // member: allocated_thrust
  {
    if (msg.allocated_thrust.size() == 0) {
      out << "allocated_thrust: []";
    } else {
      out << "allocated_thrust: [";
      size_t pending_items = msg.allocated_thrust.size();
      for (auto item : msg.allocated_thrust) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: thrust_composition
  {
    if (msg.thrust_composition.size() == 0) {
      out << "thrust_composition: []";
    } else {
      out << "thrust_composition: [";
      size_t pending_items = msg.thrust_composition.size();
      for (auto item : msg.thrust_composition) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: controllability_scaler
  {
    out << "controllability_scaler: ";
    rosidl_generator_traits::value_to_yaml(msg.controllability_scaler, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FailureControlDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: desired_thrust
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "desired_thrust:\n";
    to_block_style_yaml(msg.desired_thrust, out, indentation + 2);
  }

  // member: desired_torque
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "desired_torque:\n";
    to_block_style_yaml(msg.desired_torque, out, indentation + 2);
  }

  // member: allocated_thrust
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.allocated_thrust.size() == 0) {
      out << "allocated_thrust: []\n";
    } else {
      out << "allocated_thrust:\n";
      for (auto item : msg.allocated_thrust) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: thrust_composition
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.thrust_composition.size() == 0) {
      out << "thrust_composition: []\n";
    } else {
      out << "thrust_composition:\n";
      for (auto item : msg.thrust_composition) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: controllability_scaler
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "controllability_scaler: ";
    rosidl_generator_traits::value_to_yaml(msg.controllability_scaler, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FailureControlDebug & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_control_msgs::msg::FailureControlDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_control_msgs::msg::FailureControlDebug & msg)
{
  return hippo_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_control_msgs::msg::FailureControlDebug>()
{
  return "hippo_control_msgs::msg::FailureControlDebug";
}

template<>
inline const char * name<hippo_control_msgs::msg::FailureControlDebug>()
{
  return "hippo_control_msgs/msg/FailureControlDebug";
}

template<>
struct has_fixed_size<hippo_control_msgs::msg::FailureControlDebug>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_control_msgs::msg::FailureControlDebug>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_control_msgs::msg::FailureControlDebug>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_DEBUG__TRAITS_HPP_
