// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/FailureControlMode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/failure_control_mode.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_MODE__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__FailureControlMode __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__FailureControlMode __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FailureControlMode_
{
  using Type = FailureControlMode_<ContainerAllocator>;

  explicit FailureControlMode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0l;
    }
  }

  explicit FailureControlMode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0l;
    }
  }

  // field types and members
  using _mode_type =
    int32_t;
  _mode_type mode;

  // setters for named parameter idiom
  Type & set__mode(
    const int32_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t MODE_UNSET =
    -1;
  static constexpr int32_t MODE_IDLE =
    0;
  static constexpr int32_t MODE_UNTANGLING =
    1;
  static constexpr int32_t MODE_NORMAL =
    2;
  static constexpr int32_t MODE_SINGLE_FAILURE_UNDETECTED =
    3;
  static constexpr int32_t MODE_DOUBLE_FAILURE_UNDETECTED =
    4;
  static constexpr int32_t MODE_SINGLE_FAILURE_DETECTED =
    5;
  static constexpr int32_t MODE_DOUBLE_FAILURE_DETECTED =
    6;

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__FailureControlMode
    std::shared_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__FailureControlMode
    std::shared_ptr<hippo_control_msgs::msg::FailureControlMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FailureControlMode_ & other) const
  {
    if (this->mode != other.mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const FailureControlMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FailureControlMode_

// alias to use template instance with default allocator
using FailureControlMode =
  hippo_control_msgs::msg::FailureControlMode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_UNSET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_IDLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_UNTANGLING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_NORMAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_SINGLE_FAILURE_UNDETECTED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_DOUBLE_FAILURE_UNDETECTED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_SINGLE_FAILURE_DETECTED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t FailureControlMode_<ContainerAllocator>::MODE_DOUBLE_FAILURE_DETECTED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__FAILURE_CONTROL_MODE__STRUCT_HPP_
