// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_control_msgs:msg/QuaternionControlDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/quaternion_control_debug.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__TRAITS_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_control_msgs/msg/detail/quaternion_control_debug__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'desired_axis'
// Member 'current_axis'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace hippo_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const QuaternionControlDebug & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: roll_weight
  {
    out << "roll_weight: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_weight, out);
    out << ", ";
  }

  // member: gain
  {
    out << "gain: ";
    rosidl_generator_traits::value_to_yaml(msg.gain, out);
    out << ", ";
  }

  // member: desired_axis
  {
    out << "desired_axis: ";
    to_flow_style_yaml(msg.desired_axis, out);
    out << ", ";
  }

  // member: current_axis
  {
    out << "current_axis: ";
    to_flow_style_yaml(msg.current_axis, out);
    out << ", ";
  }

  // member: angle_error
  {
    out << "angle_error: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_error, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const QuaternionControlDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: roll_weight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_weight: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_weight, out);
    out << "\n";
  }

  // member: gain
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gain: ";
    rosidl_generator_traits::value_to_yaml(msg.gain, out);
    out << "\n";
  }

  // member: desired_axis
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "desired_axis:\n";
    to_block_style_yaml(msg.desired_axis, out, indentation + 2);
  }

  // member: current_axis
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current_axis:\n";
    to_block_style_yaml(msg.current_axis, out, indentation + 2);
  }

  // member: angle_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angle_error: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_error, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const QuaternionControlDebug & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_control_msgs::msg::QuaternionControlDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_control_msgs::msg::QuaternionControlDebug & msg)
{
  return hippo_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_control_msgs::msg::QuaternionControlDebug>()
{
  return "hippo_control_msgs::msg::QuaternionControlDebug";
}

template<>
inline const char * name<hippo_control_msgs::msg::QuaternionControlDebug>()
{
  return "hippo_control_msgs/msg/QuaternionControlDebug";
}

template<>
struct has_fixed_size<hippo_control_msgs::msg::QuaternionControlDebug>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_control_msgs::msg::QuaternionControlDebug>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_control_msgs::msg::QuaternionControlDebug>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__QUATERNION_CONTROL_DEBUG__TRAITS_HPP_
