// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hippo_control_msgs:msg/RatesTarget.idl
// generated code does not contain a copyright notice
#include "hippo_control_msgs/msg/detail/rates_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
hippo_control_msgs__msg__RatesTarget__init(hippo_control_msgs__msg__RatesTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    hippo_control_msgs__msg__RatesTarget__fini(msg);
    return false;
  }
  // ignore_roll
  // ignore_pitch
  // ignore_yaw
  // roll
  // pitch
  // yaw
  // reset_integral
  return true;
}

void
hippo_control_msgs__msg__RatesTarget__fini(hippo_control_msgs__msg__RatesTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ignore_roll
  // ignore_pitch
  // ignore_yaw
  // roll
  // pitch
  // yaw
  // reset_integral
}

bool
hippo_control_msgs__msg__RatesTarget__are_equal(const hippo_control_msgs__msg__RatesTarget * lhs, const hippo_control_msgs__msg__RatesTarget * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // ignore_roll
  if (lhs->ignore_roll != rhs->ignore_roll) {
    return false;
  }
  // ignore_pitch
  if (lhs->ignore_pitch != rhs->ignore_pitch) {
    return false;
  }
  // ignore_yaw
  if (lhs->ignore_yaw != rhs->ignore_yaw) {
    return false;
  }
  // roll
  if (lhs->roll != rhs->roll) {
    return false;
  }
  // pitch
  if (lhs->pitch != rhs->pitch) {
    return false;
  }
  // yaw
  if (lhs->yaw != rhs->yaw) {
    return false;
  }
  // reset_integral
  if (lhs->reset_integral != rhs->reset_integral) {
    return false;
  }
  return true;
}

bool
hippo_control_msgs__msg__RatesTarget__copy(
  const hippo_control_msgs__msg__RatesTarget * input,
  hippo_control_msgs__msg__RatesTarget * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // ignore_roll
  output->ignore_roll = input->ignore_roll;
  // ignore_pitch
  output->ignore_pitch = input->ignore_pitch;
  // ignore_yaw
  output->ignore_yaw = input->ignore_yaw;
  // roll
  output->roll = input->roll;
  // pitch
  output->pitch = input->pitch;
  // yaw
  output->yaw = input->yaw;
  // reset_integral
  output->reset_integral = input->reset_integral;
  return true;
}

hippo_control_msgs__msg__RatesTarget *
hippo_control_msgs__msg__RatesTarget__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__RatesTarget * msg = (hippo_control_msgs__msg__RatesTarget *)allocator.allocate(sizeof(hippo_control_msgs__msg__RatesTarget), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hippo_control_msgs__msg__RatesTarget));
  bool success = hippo_control_msgs__msg__RatesTarget__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hippo_control_msgs__msg__RatesTarget__destroy(hippo_control_msgs__msg__RatesTarget * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hippo_control_msgs__msg__RatesTarget__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hippo_control_msgs__msg__RatesTarget__Sequence__init(hippo_control_msgs__msg__RatesTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__RatesTarget * data = NULL;

  if (size) {
    data = (hippo_control_msgs__msg__RatesTarget *)allocator.zero_allocate(size, sizeof(hippo_control_msgs__msg__RatesTarget), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hippo_control_msgs__msg__RatesTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hippo_control_msgs__msg__RatesTarget__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hippo_control_msgs__msg__RatesTarget__Sequence__fini(hippo_control_msgs__msg__RatesTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hippo_control_msgs__msg__RatesTarget__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hippo_control_msgs__msg__RatesTarget__Sequence *
hippo_control_msgs__msg__RatesTarget__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_control_msgs__msg__RatesTarget__Sequence * array = (hippo_control_msgs__msg__RatesTarget__Sequence *)allocator.allocate(sizeof(hippo_control_msgs__msg__RatesTarget__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hippo_control_msgs__msg__RatesTarget__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hippo_control_msgs__msg__RatesTarget__Sequence__destroy(hippo_control_msgs__msg__RatesTarget__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hippo_control_msgs__msg__RatesTarget__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hippo_control_msgs__msg__RatesTarget__Sequence__are_equal(const hippo_control_msgs__msg__RatesTarget__Sequence * lhs, const hippo_control_msgs__msg__RatesTarget__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hippo_control_msgs__msg__RatesTarget__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hippo_control_msgs__msg__RatesTarget__Sequence__copy(
  const hippo_control_msgs__msg__RatesTarget__Sequence * input,
  hippo_control_msgs__msg__RatesTarget__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hippo_control_msgs__msg__RatesTarget);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hippo_control_msgs__msg__RatesTarget * data =
      (hippo_control_msgs__msg__RatesTarget *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hippo_control_msgs__msg__RatesTarget__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hippo_control_msgs__msg__RatesTarget__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hippo_control_msgs__msg__RatesTarget__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
