// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_control_msgs:msg/RatesTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/rates_target.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__STRUCT_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_control_msgs__msg__RatesTarget __attribute__((deprecated))
#else
# define DEPRECATED__hippo_control_msgs__msg__RatesTarget __declspec(deprecated)
#endif

namespace hippo_control_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RatesTarget_
{
  using Type = RatesTarget_<ContainerAllocator>;

  explicit RatesTarget_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_roll = false;
      this->ignore_pitch = false;
      this->ignore_yaw = false;
      this->roll = 0.0;
      this->pitch = 0.0;
      this->yaw = 0.0;
      this->reset_integral = false;
    }
  }

  explicit RatesTarget_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_roll = false;
      this->ignore_pitch = false;
      this->ignore_yaw = false;
      this->roll = 0.0;
      this->pitch = 0.0;
      this->yaw = 0.0;
      this->reset_integral = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _ignore_roll_type =
    bool;
  _ignore_roll_type ignore_roll;
  using _ignore_pitch_type =
    bool;
  _ignore_pitch_type ignore_pitch;
  using _ignore_yaw_type =
    bool;
  _ignore_yaw_type ignore_yaw;
  using _roll_type =
    double;
  _roll_type roll;
  using _pitch_type =
    double;
  _pitch_type pitch;
  using _yaw_type =
    double;
  _yaw_type yaw;
  using _reset_integral_type =
    bool;
  _reset_integral_type reset_integral;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__ignore_roll(
    const bool & _arg)
  {
    this->ignore_roll = _arg;
    return *this;
  }
  Type & set__ignore_pitch(
    const bool & _arg)
  {
    this->ignore_pitch = _arg;
    return *this;
  }
  Type & set__ignore_yaw(
    const bool & _arg)
  {
    this->ignore_yaw = _arg;
    return *this;
  }
  Type & set__roll(
    const double & _arg)
  {
    this->roll = _arg;
    return *this;
  }
  Type & set__pitch(
    const double & _arg)
  {
    this->pitch = _arg;
    return *this;
  }
  Type & set__yaw(
    const double & _arg)
  {
    this->yaw = _arg;
    return *this;
  }
  Type & set__reset_integral(
    const bool & _arg)
  {
    this->reset_integral = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_control_msgs__msg__RatesTarget
    std::shared_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_control_msgs__msg__RatesTarget
    std::shared_ptr<hippo_control_msgs::msg::RatesTarget_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RatesTarget_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->ignore_roll != other.ignore_roll) {
      return false;
    }
    if (this->ignore_pitch != other.ignore_pitch) {
      return false;
    }
    if (this->ignore_yaw != other.ignore_yaw) {
      return false;
    }
    if (this->roll != other.roll) {
      return false;
    }
    if (this->pitch != other.pitch) {
      return false;
    }
    if (this->yaw != other.yaw) {
      return false;
    }
    if (this->reset_integral != other.reset_integral) {
      return false;
    }
    return true;
  }
  bool operator!=(const RatesTarget_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RatesTarget_

// alias to use template instance with default allocator
using RatesTarget =
  hippo_control_msgs::msg::RatesTarget_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_control_msgs

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__STRUCT_HPP_
