// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_control_msgs:msg/RatesTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_control_msgs/msg/rates_target.hpp"


#ifndef HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__TRAITS_HPP_
#define HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_control_msgs/msg/detail/rates_target__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hippo_control_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RatesTarget & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: ignore_roll
  {
    out << "ignore_roll: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_roll, out);
    out << ", ";
  }

  // member: ignore_pitch
  {
    out << "ignore_pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_pitch, out);
    out << ", ";
  }

  // member: ignore_yaw
  {
    out << "ignore_yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_yaw, out);
    out << ", ";
  }

  // member: roll
  {
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << ", ";
  }

  // member: pitch
  {
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << ", ";
  }

  // member: yaw
  {
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
    out << ", ";
  }

  // member: reset_integral
  {
    out << "reset_integral: ";
    rosidl_generator_traits::value_to_yaml(msg.reset_integral, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RatesTarget & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: ignore_roll
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_roll: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_roll, out);
    out << "\n";
  }

  // member: ignore_pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_pitch, out);
    out << "\n";
  }

  // member: ignore_yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_yaw, out);
    out << "\n";
  }

  // member: roll
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
    out << "\n";
  }

  // member: reset_integral
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reset_integral: ";
    rosidl_generator_traits::value_to_yaml(msg.reset_integral, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RatesTarget & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_control_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_control_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_control_msgs::msg::RatesTarget & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_control_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_control_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_control_msgs::msg::RatesTarget & msg)
{
  return hippo_control_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_control_msgs::msg::RatesTarget>()
{
  return "hippo_control_msgs::msg::RatesTarget";
}

template<>
inline const char * name<hippo_control_msgs::msg::RatesTarget>()
{
  return "hippo_control_msgs/msg/RatesTarget";
}

template<>
struct has_fixed_size<hippo_control_msgs::msg::RatesTarget>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_control_msgs::msg::RatesTarget>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_control_msgs::msg::RatesTarget>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_CONTROL_MSGS__MSG__DETAIL__RATES_TARGET__TRAITS_HPP_
